# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl CBTags.t'

#########################

# change 'tests => 1' to 'tests => last_test_to_print';

use Test::More tests => 14;
BEGIN { use_ok('CBTags') };

#########################

{
	my $name = 'simple adds';

	my $cbtags = CBTags->new('dbi:SQLite::memory:');

	$cbtags->create_tag('one');
	$cbtags->create_tag('two');
	$cbtags->create_tag('three');

	$cbtags->create_file('fileA', '/tmp/fileA');
	$cbtags->create_file('fileB', '/tmp/fileB');
	$cbtags->create_file('fileC', '/tmp/fileC');

	$cbtags->add_tag('fileA', 'one');
	$cbtags->add_tag('fileA', 'three');
	$cbtags->add_tag('fileB', 'one');
	$cbtags->add_tag('fileB', 'two');

	is_deeply([sort($cbtags->get_tags('fileA'))], [sort qw(one three)], $name);
	is_deeply([sort($cbtags->get_tags('fileB'))], [sort qw(one two)], $name);
	is_deeply([sort($cbtags->get_tags('fileC'))], [], $name);

	is($cbtags->file_location('fileA'), '/tmp/fileA', $name);
	is($cbtags->file_location('fileB'), '/tmp/fileB', $name);
	is($cbtags->file_location('fileC'), '/tmp/fileC', $name);

	is_deeply([sort($cbtags->get_files('one'))], [qw(fileA fileB)], $name);
	is_deeply([sort($cbtags->get_files('two'))], [qw(fileB)], $name);
	is_deeply([sort($cbtags->get_files('three'))], [qw(fileA)], $name);

	is_deeply([sort($cbtags->get_files(qw(one two three)))], [], $name);
	is_deeply([sort($cbtags->get_files(qw(one two)))], ['fileB'], $name);
	is_deeply([sort($cbtags->get_files(qw(one three)))], ['fileA'], $name);
	is_deeply([sort($cbtags->get_files(qw(two three)))], [], $name);
}
